LeetCode821字符串的最短距离----双指针、两次遍历
题目表述
给你一个字符串 s 和一个字符 c ,且 c 是 s 中出现过的字符。
返回一个整数数组 answer ,其中 answer.length == s.length 且 answer[i] 是 s 中从下标 i 到离它 最近 的字符 c 的 距离 。
两个下标 i 和 j 之间的 距离 为 abs(i - j) ,其中 abs 是绝对值函数。
示例:
输入:s = "loveleetcode", c = "e"
输出:[3,2,1,0,1,0,0,1,2,2,1,0]
解释:字符 'e' 出现在下标 3、5、6 和 11 处(下标从 0 开始计数)。
距下标 0 最近的 'e' 出现在下标 3 ,所以距离为 abs(0 - 3) = 3 。
距下标 1 最近的 'e' 出现在下标 3 ,所以距离为 abs(1 - 3) = 2 。
对于下标 4 ,出现在下标 3 和下标 5 处的 'e' 都离它最近,但距离是一样的 abs(4 - 3) == abs(4 - 5) = 1 。
距下标 8 最近的 'e' 出现在下标 6 ,所以距离为 abs(8 - 6) = 2 。
双指针
该题我使用了双指针来解,想的就是找到两个字符c的下标,初始化一个preIndex为-n,一个right,代表当前字符左边的c和当前字符右边c的位置。比较当前字符距离哪个字符c距离最近,取最近的距离即可。
最后若right == n 且 right != preIndex + 1,则说明最后一个字符c不是在字符串末尾,只需从当前下标位置计算与preIndex的距离即可。
代码里面使用了双重循环,但本质上算法时间复杂度为O(n)。该题与官解思路一样,代码实现有所差异。下面是自己写的代码和管解,相比还是管解更容易理解。
双指针解法:
class Solution {
public int[] shortestToChar(String s, char c) {
int n = s.length();
int[] answer = new int[n];
int preIndex = -n;
int left = 0,right = 0;
while(right < n){
while(right < n && s.charAt(right) != c){
right++;
}
if(right == n) break;
while(left <= right){
answer[left] = Math.min(left - preIndex,right - left);
left++;
}
preIndex = right;
right++;
}
if(preIndex + 1 < right){
while(left < n){
answer[left] = left - preIndex;
left++;
}
}
return answer;
}
}
官方解法:
class Solution {
public int[] shortestToChar(String s, char c) {
int n = s.length();
int[] ans = new int[n];
for (int i = 0, idx = -n; i < n; ++i) {
if (s.charAt(i) == c) {
idx = i;
}
ans[i] = i - idx;
}
for (int i = n - 1, idx = 2 * n; i >= 0; --i) {
if (s.charAt(i) == c) {
idx = i;
}
ans[i] = Math.min(ans[i], idx - i);
}
return ans;
}
}